import * as iam from "../../../aws-iam";
import * as sns from "../../../aws-sns";
import { CommonConstraintOptions, StackSetsConstraintOptions, TagUpdateConstraintOptions } from '../constraints';
import { IPortfolio } from '../portfolio';
import { IProduct } from '../product';
import { CfnPortfolioProductAssociation } from '../servicecatalog.generated';
import { TagOptions } from '../tag-options';
export declare class AssociationManager {
    static associateProductWithPortfolio(portfolio: IPortfolio, product: IProduct): {
        associationKey: string;
        cfnPortfolioProductAssociation: CfnPortfolioProductAssociation;
    };
    static constrainTagUpdates(portfolio: IPortfolio, product: IProduct, options: TagUpdateConstraintOptions): void;
    static notifyOnStackEvents(portfolio: IPortfolio, product: IProduct, topic: sns.ITopic, options: CommonConstraintOptions): void;
    static setLaunchRole(portfolio: IPortfolio, product: IProduct, launchRole: iam.IRole, options: CommonConstraintOptions): void;
    static deployWithStackSets(portfolio: IPortfolio, product: IProduct, options: StackSetsConstraintOptions): void;
    static associateTagOptions(portfolio: IPortfolio, tagOptions: TagOptions): void;
    private static stackSetConstraintLogicalId;
    private static launchRoleConstraintLogicalId;
    private static prettyPrintAssociation;
    private static validateCommonConstraintOptions;
}
